diff --git a/src/Lunr/Vortex/APNS/APNSPayload.php b/src/Lunr/Vortex/APNS/APNSPayload.php
index 7993ba8e77c8263751e21e4d99a7a45106943553..f7372ff5cb8f97460ceb158239ca4e50af62dbcd 100644
--- a/src/Lunr/Vortex/APNS/APNSPayload.php
+++ b/src/Lunr/Vortex/APNS/APNSPayload.php
@@ -23,7 +23,7 @@ class APNSPayload
      * Array of Push Notification elements.
      * @var array
      */
-    protected $elements;
+    protected array $elements;
 
     /**
      * Constructor.
@@ -48,7 +48,7 @@ class APNSPayload
      *
      * @return array APNSPayload elements
      */
-    public function get_payload()
+    public function get_payload(): array
     {
         return $this->elements;
     }
@@ -63,7 +63,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_collapse_key($key)
+    public function set_collapse_key(string $key): self
     {
         $this->elements['collapse_key'] = $key;
 
@@ -79,7 +79,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_topic($topic)
+    public function set_topic(string $topic): self
     {
         $this->elements['topic'] = $topic;
 
@@ -93,7 +93,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_priority($priority)
+    public function set_priority(int $priority): self
     {
         $priority       = $priority;
         $priority_class = new ReflectionClass('\Lunr\Vortex\APNS\APNSPriority');
@@ -114,7 +114,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_badge($badge)
+    public function set_badge(int $badge): self
     {
         $this->elements['badge'] = $badge;
 
@@ -128,7 +128,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_sound($sound)
+    public function set_sound(string $sound): self
     {
         $this->elements['sound'] = $sound;
 
@@ -142,7 +142,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_thread_id($thread_id)
+    public function set_thread_id(string $thread_id): self
     {
         $this->elements['thread_id'] = $thread_id;
 
@@ -156,7 +156,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_identifier($identifier)
+    public function set_identifier(string $identifier): self
     {
         $this->elements['identifier'] = $identifier;
 
@@ -170,7 +170,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_category($category)
+    public function set_category(string $category): self
     {
         $this->elements['category'] = $category;
 
@@ -184,7 +184,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_content_available($content_available)
+    public function set_content_available(bool $content_available): self
     {
         $this->elements['content_available'] = $content_available;
 
@@ -198,7 +198,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_mutable_content($mutable_content)
+    public function set_mutable_content(bool $mutable_content): self
     {
         $this->elements['mutable_content'] = $mutable_content;
 
@@ -212,7 +212,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_title($title)
+    public function set_title(string $title): self
     {
         $this->elements['title'] = $title;
 
@@ -226,7 +226,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_body($body)
+    public function set_body(string $body): self
     {
         $this->elements['body'] = $body;
 
@@ -246,7 +246,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_alert($alert)
+    public function set_alert(string $alert): self
     {
         return $this->set_body($alert);
     }
@@ -259,7 +259,7 @@ class APNSPayload
      *
      * @return APNSPayload Self Reference
      */
-    public function set_custom_data($key, $value)
+    public function set_custom_data(string $key, string $value): self
     {
         if (!isset($this->elements['custom_data']))
         {
diff --git a/src/Lunr/Vortex/APNS/APNSPriority.php b/src/Lunr/Vortex/APNS/APNSPriority.php
index d919236461086f5723ee9cd6622ab01e818af008..6a251a68d18334d5312ae9f9adb53669d80068c2 100644
--- a/src/Lunr/Vortex/APNS/APNSPriority.php
+++ b/src/Lunr/Vortex/APNS/APNSPriority.php
@@ -19,15 +19,15 @@ class APNSPriority
 
     /**
      * Deliver notification immediately.
-     * @var string
+     * @var int
      */
-    const HIGH = 10;
+    public const HIGH = 10;
 
     /**
      * Deliver notification with normal priority.
-     * @var string
+     * @var int
      */
-    const NORMAL = 5;
+    public const NORMAL = 5;
 
 }
 
diff --git a/src/Lunr/Vortex/APNS/ApnsPHP/APNSBinaryStatus.php b/src/Lunr/Vortex/APNS/ApnsPHP/APNSBinaryStatus.php
index 5ef13c2394081eee25fddcff3b96f8ef4f4badec..037b45a1bcdb4dfdf702b7f6251f9bede2cb58a1 100644
--- a/src/Lunr/Vortex/APNS/ApnsPHP/APNSBinaryStatus.php
+++ b/src/Lunr/Vortex/APNS/ApnsPHP/APNSBinaryStatus.php
@@ -21,73 +21,73 @@ class APNSBinaryStatus
      * No error encountered.
      * @var integer
      */
-    const SUCCESS = 0;
+    public const SUCCESS = 0;
 
     /**
      * Processing error.
      * @var integer
      */
-    const ERROR_PROCESSING = 1;
+    public const ERROR_PROCESSING = 1;
 
     /**
      * Missing device token error.
      * @var integer
      */
-    const ERROR_MISSING_DEVICE_TOKEN = 2;
+    public const ERROR_MISSING_DEVICE_TOKEN = 2;
 
     /**
      * Missing topic error.
      * @var integer
      */
-    const ERROR_TOPIC = 3;
+    public const ERROR_TOPIC = 3;
 
     /**
      * Missing payload error.
      * @var integer
      */
-    const ERROR_MISSING_PAYLOAD = 4;
+    public const ERROR_MISSING_PAYLOAD = 4;
 
     /**
      * Invalid token size error.
      * @var integer
      */
-    const ERROR_INVALID_TOKEN_SIZE = 5;
+    public const ERROR_INVALID_TOKEN_SIZE = 5;
 
     /**
      * Invalid topic size error.
      * @var integer
      */
-    const ERROR_INVALID_TOPIC_SIZE = 6;
+    public const ERROR_INVALID_TOPIC_SIZE = 6;
 
     /**
      * Invalid payload size error.
      * @var integer
      */
-    const ERROR_INVALID_PAYLOAD_SIZE = 7;
+    public const ERROR_INVALID_PAYLOAD_SIZE = 7;
 
     /**
      * Invalid token error.
      * @var integer
      */
-    const ERROR_INVALID_TOKEN = 8;
+    public const ERROR_INVALID_TOKEN = 8;
 
     /**
      * Shutdown error.
      * @var integer
      */
-    const ERROR_SHUTDOWN = 10;
+    public const ERROR_SHUTDOWN = 10;
 
     /**
      * Protocol error,
      * @var integer
      */
-    const ERROR_PROTOCOL = 128;
+    public const ERROR_PROTOCOL = 128;
 
     /**
      * Unknown error.
      * @var integer
      */
-    const ERROR_UNKNOWN = 255;
+    public const ERROR_UNKNOWN = 255;
 
 }
 
diff --git a/src/Lunr/Vortex/APNS/ApnsPHP/APNSDispatcher.php b/src/Lunr/Vortex/APNS/ApnsPHP/APNSDispatcher.php
index 1b3f2aa1c5eb5928237a47da7f92f085f304d99d..61dc734d40a635fdef8017e66f99f7dad688ae8f 100644
--- a/src/Lunr/Vortex/APNS/ApnsPHP/APNSDispatcher.php
+++ b/src/Lunr/Vortex/APNS/ApnsPHP/APNSDispatcher.php
@@ -16,6 +16,8 @@ use \ApnsPHP_Message_Exception;
 use \ApnsPHP_Exception;
 use Lunr\Vortex\APNS\APNSPayload;
 use Lunr\Vortex\PushNotificationMultiDispatcherInterface;
+use Lunr\Vortex\PushNotificationResponseInterface;
+use Psr\Log\LoggerInterface;
 
 /**
  * Apple Push Notification Service Push Notification Dispatcher.
@@ -27,19 +29,19 @@ class APNSDispatcher implements PushNotificationMultiDispatcherInterface
      * Shared instance of ApnsPHP_Push.
      * @var \ApnsPHP_Push
      */
-    protected $apns_push;
+    protected \ApnsPHP_Push $apns_push;
 
     /**
      * Apns Message instance
      * @var \ApnsPHP_Message
      */
-    protected $apns_message;
+    protected \ApnsPHP_Message $apns_message;
 
     /**
      * Shared instance of a Logger class.
      * @var \Psr\Log\LoggerInterface
      */
-    protected $logger;
+    protected LoggerInterface $logger;
 
     /**
      * Constructor.
@@ -47,7 +49,7 @@ class APNSDispatcher implements PushNotificationMultiDispatcherInterface
      * @param \Psr\Log\LoggerInterface $logger    Shared instance of a Logger.
      * @param \ApnsPHP_Push            $apns_push Apns Push instance.
      */
-    public function __construct($logger, $apns_push)
+    public function __construct(LoggerInterface $logger, \ApnsPHP_Push $apns_push)
     {
         $this->logger    = $logger;
         $this->apns_push = $apns_push;
@@ -70,7 +72,7 @@ class APNSDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return void
      */
-    protected function reset()
+    protected function reset(): void
     {
         unset($this->apns_message);
     }
@@ -80,7 +82,7 @@ class APNSDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return \ApnsPHP_Message
      */
-    protected function get_new_apns_message()
+    protected function get_new_apns_message(): ApnsPHP_Message
     {
         return new ApnsPHP_Message();
     }
@@ -91,9 +93,9 @@ class APNSDispatcher implements PushNotificationMultiDispatcherInterface
      * @param APNSPayload $payload   Payload object
      * @param array       $endpoints Endpoints to send to in this batch
      *
-     * @return APNSResponse Response object
+     * @return PushNotificationResponseInterface&APNSResponse Response object
      */
-    public function push($payload, &$endpoints)
+    public function push(object $payload, array &$endpoints): PushNotificationResponseInterface
     {
         // Create message
         $payload = $payload->get_payload();
diff --git a/src/Lunr/Vortex/APNS/ApnsPHP/APNSHttpStatus.php b/src/Lunr/Vortex/APNS/ApnsPHP/APNSHttpStatus.php
index b23ad244047f81686ebacefcefafc597bc2eecf0..c6d20a9909ded5235b0adb69d00720c964036611 100644
--- a/src/Lunr/Vortex/APNS/ApnsPHP/APNSHttpStatus.php
+++ b/src/Lunr/Vortex/APNS/ApnsPHP/APNSHttpStatus.php
@@ -21,49 +21,49 @@ class APNSHttpStatus
      * No error encountered.
      * @var integer
      */
-    const SUCCESS = 200;
+    public const SUCCESS = 200;
 
     /**
      * Bad request error.
      * @var integer
      */
-    const ERROR_BAD_REQUEST = 400;
+    public const ERROR_BAD_REQUEST = 400;
 
     /**
      * Certificate or token error.
      * @var integer
      */
-    const ERROR_AUTHENTICATION = 403;
+    public const ERROR_AUTHENTICATION = 403;
 
     /**
      * The device token is inactive for the specified topic.
      * @var integer
      */
-    const ERROR_UNREGISTERED = 410;
+    public const ERROR_UNREGISTERED = 410;
 
     /**
      * The message payload was too large.
      * @var integer
      */
-    const ERROR_PAYLOAD_TOO_LARGE = 413;
+    public const ERROR_PAYLOAD_TOO_LARGE = 413;
 
     /**
      * The provider token is being updated too often.
      * @var integer
      */
-    const TOO_MANY_REQUESTS = 429;
+    public const TOO_MANY_REQUESTS = 429;
 
     /**
      * Unknown internal error.
      * @var integer
      */
-    const ERROR_INTERNAL_ERROR = 500;
+    public const ERROR_INTERNAL_ERROR = 500;
 
     /**
      * Shutdown error.
      * @var integer
      */
-    const ERROR_SHUTDOWN = 503;
+    public const ERROR_SHUTDOWN = 503;
 
 }
 
diff --git a/src/Lunr/Vortex/APNS/ApnsPHP/APNSHttpStatusReason.php b/src/Lunr/Vortex/APNS/ApnsPHP/APNSHttpStatusReason.php
index e858bb040585fb457f9314266203a2b6a02082d2..94e3311925eea3bbc2ffe5822054461c76ae53ae 100644
--- a/src/Lunr/Vortex/APNS/ApnsPHP/APNSHttpStatusReason.php
+++ b/src/Lunr/Vortex/APNS/ApnsPHP/APNSHttpStatusReason.php
@@ -21,91 +21,91 @@ class APNSHttpStatusReason
      * Bad token error.
      * @var string
      */
-    const ERROR_BAD_TOKEN = 'BadDeviceToken';
+    public const ERROR_BAD_TOKEN = 'BadDeviceToken';
 
     /**
      * Bad collapse ID error.
      * @var string
      */
-    const ERROR_BAD_COLLAPSE_ID = 'BadCollapseId';
+    public const ERROR_BAD_COLLAPSE_ID = 'BadCollapseId';
 
     /**
      * Bad expiration date error.
      * @var string
      */
-    const ERROR_BAD_EXPIRATION_DATE = 'BadExpirationDate';
+    public const ERROR_BAD_EXPIRATION_DATE = 'BadExpirationDate';
 
     /**
      * Bad message ID error.
      * @var string
      */
-    const ERROR_BAD_MESSAGE_ID = 'BadMessageId';
+    public const ERROR_BAD_MESSAGE_ID = 'BadMessageId';
 
     /**
      * Bad priority error.
      * @var string
      */
-    const ERROR_BAD_PRIORITY = 'BadPriority';
+    public const ERROR_BAD_PRIORITY = 'BadPriority';
 
     /**
      * Bad topic error.
      * @var string
      */
-    const ERROR_BAD_TOPIC = 'BadTopic';
+    public const ERROR_BAD_TOPIC = 'BadTopic';
 
     /**
      * Token not for current topic error.
      * @var string
      */
-    const ERROR_NON_MATCHING_TOKEN = 'DeviceTokenNotForTopic';
+    public const ERROR_NON_MATCHING_TOKEN = 'DeviceTokenNotForTopic';
 
     /**
      * Idle timeout.
      * @var string
      */
-    const ERROR_IDLE_TIMEOUT = 'IdleTimeout';
+    public const ERROR_IDLE_TIMEOUT = 'IdleTimeout';
 
     /**
      * Topic not allowed error.
      * @var string
      */
-    const ERROR_TOPIC_BLOCKED = 'TopicDisallowed';
+    public const ERROR_TOPIC_BLOCKED = 'TopicDisallowed';
 
     /**
      * Certificate is not valid.
      * @var string
      */
-    const ERROR_CERTIFICATE_INVALID = 'BadCertificate';
+    public const ERROR_CERTIFICATE_INVALID = 'BadCertificate';
 
     /**
      * Certificate does not match requested environment.
      * @var string
      */
-    const ERROR_CERTIFICATE_ENVIRONMENT = 'BadCertificateEnvironment';
+    public const ERROR_CERTIFICATE_ENVIRONMENT = 'BadCertificateEnvironment';
 
     /**
      * JWT Provider token is expired.
      * @var string
      */
-    const ERROR_EXPIRED_AUTH_TOKEN = 'ExpiredProviderToken';
+    public const ERROR_EXPIRED_AUTH_TOKEN = 'ExpiredProviderToken';
 
     /**
      * JWT Provider token is invalid.
      * @var string
      */
-    const ERROR_INVALID_AUTH_TOKEN = 'InvalidProviderToken';
+    public const ERROR_INVALID_AUTH_TOKEN = 'InvalidProviderToken';
 
     /**
      * JWT Provider token is missing.
      * @var string
      */
-    const ERROR_MISSING_AUTH_TOKEN = 'MissingProviderToken';
+    public const ERROR_MISSING_AUTH_TOKEN = 'MissingProviderToken';
 
     /**
      * Action is forbidden.
      * @var string
      */
-    const ERROR_FORBIDDEN = 'Forbidden';
+    public const ERROR_FORBIDDEN = 'Forbidden';
 
 }
 
diff --git a/src/Lunr/Vortex/APNS/ApnsPHP/APNSResponse.php b/src/Lunr/Vortex/APNS/ApnsPHP/APNSResponse.php
index bc22591f1f329e9fc4c06c268f44fb318612d969..fb4b40149efbfaa7a664e5ff55f6ca4c65a716f0 100644
--- a/src/Lunr/Vortex/APNS/ApnsPHP/APNSResponse.php
+++ b/src/Lunr/Vortex/APNS/ApnsPHP/APNSResponse.php
@@ -13,6 +13,7 @@ namespace Lunr\Vortex\APNS\ApnsPHP;
 
 use Lunr\Vortex\PushNotificationStatus;
 use Lunr\Vortex\PushNotificationResponseInterface;
+use Psr\Log\LoggerInterface;
 
 /**
  * Apple Push Notification Service response wrapper.
@@ -24,19 +25,19 @@ class APNSResponse implements PushNotificationResponseInterface
      * Shared instance of a Logger class.
      * @var \Psr\Log\LoggerInterface
      */
-    protected $logger;
+    protected LoggerInterface $logger;
 
     /**
      * The statuses per endpoint.
      * @var array<PushNotificationStatus::*>
      */
-    protected $statuses;
+    protected array $statuses;
 
     /**
      * Raw payload that was sent to APNS.
      * @var string
      */
-    protected $payload;
+    protected string $payload;
 
     /**
      * Constructor.
@@ -47,7 +48,7 @@ class APNSResponse implements PushNotificationResponseInterface
      * @param array                    $errors            The errors response from the APNS Push.
      * @param string                   $payload           Raw payload that was sent to APNS.
      */
-    public function __construct($logger, $endpoints, $invalid_endpoints, $errors, $payload)
+    public function __construct(LoggerInterface $logger, array $endpoints, array $invalid_endpoints, array $errors, string $payload)
     {
         $this->logger   = $logger;
         $this->statuses = [];
@@ -83,7 +84,7 @@ class APNSResponse implements PushNotificationResponseInterface
      *
      * @return void
      */
-    protected function set_statuses($endpoints, $errors)
+    protected function set_statuses(array $endpoints, array $errors): void
     {
         foreach ($errors as $error)
         {
@@ -164,7 +165,7 @@ class APNSResponse implements PushNotificationResponseInterface
      *
      * @return void
      */
-    protected function report_invalid_endpoints(&$invalid_endpoints)
+    protected function report_invalid_endpoints(array &$invalid_endpoints): void
     {
         foreach ($invalid_endpoints as $invalid_endpoint)
         {
@@ -179,7 +180,7 @@ class APNSResponse implements PushNotificationResponseInterface
      *
      * @return void
      */
-    protected function report_error(&$endpoints)
+    protected function report_error(array &$endpoints): void
     {
         foreach ($endpoints as $endpoint)
         {
@@ -197,7 +198,7 @@ class APNSResponse implements PushNotificationResponseInterface
      *
      * @return PushNotificationStatus::* Delivery status for the endpoint
      */
-    public function get_status($endpoint)
+    public function get_status(string $endpoint): int
     {
         return isset($this->statuses[$endpoint]) ? $this->statuses[$endpoint] : PushNotificationStatus::UNKNOWN;
     }
diff --git a/src/Lunr/Vortex/APNS/ApnsPHP/Tests/APNSDispatcherPushTest.php b/src/Lunr/Vortex/APNS/ApnsPHP/Tests/APNSDispatcherPushTest.php
index b2a84f0eed10152544976dad0253de7aad6e2d6a..e81d7eda5dacbfe61be780791099b2cfad3c5b65 100644
--- a/src/Lunr/Vortex/APNS/ApnsPHP/Tests/APNSDispatcherPushTest.php
+++ b/src/Lunr/Vortex/APNS/ApnsPHP/Tests/APNSDispatcherPushTest.php
@@ -58,7 +58,7 @@ class APNSDispatcherPushTest extends APNSDispatcherTest
 
         $this->payload->expects($this->once())
                       ->method('get_payload')
-                      ->willReturn('{"yo"}');
+                      ->willReturn(['yo' => 'data']);
 
         $result = $this->class->push($this->payload, $endpoints);
 
diff --git a/src/Lunr/Vortex/APNS/Tests/APNSPayloadSetTest.php b/src/Lunr/Vortex/APNS/Tests/APNSPayloadSetTest.php
index 58608fd77de641c848e799ad8c635bb8e3177784..960bd661cccec50c6decf25e0b14766de04a450a 100644
--- a/src/Lunr/Vortex/APNS/Tests/APNSPayloadSetTest.php
+++ b/src/Lunr/Vortex/APNS/Tests/APNSPayloadSetTest.php
@@ -231,7 +231,7 @@ class APNSPayloadSetTest extends APNSPayloadTest
      */
     public function testSetBadgeReturnsSelfReference(): void
     {
-        $this->assertSame($this->class, $this->class->set_badge('badge'));
+        $this->assertSame($this->class, $this->class->set_badge(1));
     }
 
     /**
@@ -321,7 +321,7 @@ class APNSPayloadSetTest extends APNSPayloadTest
      */
     public function testSetPriorityReturnsSelfReference(): void
     {
-        $this->assertSame($this->class, $this->class->set_priority('badge'));
+        $this->assertSame($this->class, $this->class->set_priority(5));
     }
 
     /**
diff --git a/src/Lunr/Vortex/Email/EmailDispatcher.php b/src/Lunr/Vortex/Email/EmailDispatcher.php
index 5de1b12ebe85181be3c087c08605eeaefd06d8e0..54d24c4e38176adab6a82bfc0cd2ec4e6fa60e7f 100644
--- a/src/Lunr/Vortex/Email/EmailDispatcher.php
+++ b/src/Lunr/Vortex/Email/EmailDispatcher.php
@@ -12,7 +12,10 @@
 namespace Lunr\Vortex\Email;
 
 use Lunr\Vortex\PushNotificationMultiDispatcherInterface;
+use Lunr\Vortex\PushNotificationResponseInterface;
 use PHPMailer\PHPMailer\Exception as PHPMailerException;
+use PHPMailer\PHPMailer\PHPMailer;
+use Psr\Log\LoggerInterface;
 
 /**
  * Email Notification Dispatcher.
@@ -23,19 +26,19 @@ class EmailDispatcher implements PushNotificationMultiDispatcherInterface
      * Email Notification source.
      * @var string
      */
-    private $source;
+    private string $source;
 
     /**
      * Shared instance of the mail transport class.
      * @var \PHPMailer\PHPMailer\PHPMailer
      */
-    private $mail_transport;
+    private PHPMailer $mail_transport;
 
     /**
      * Shared instance of a Logger class.
      * @var \Psr\Log\LoggerInterface
      */
-    private $logger;
+    private LoggerInterface $logger;
 
     /**
      * Constructor.
@@ -43,7 +46,7 @@ class EmailDispatcher implements PushNotificationMultiDispatcherInterface
      * @param \PHPMailer\PHPMailer\PHPMailer $mail_transport Shared instance of the mail transport class.
      * @param \Psr\Log\LoggerInterface       $logger         Shared instance of a Logger.
      */
-    public function __construct($mail_transport, $logger)
+    public function __construct(PHPMailer $mail_transport, LoggerInterface $logger)
     {
         $this->source = '';
         $this->logger = $logger;
@@ -66,7 +69,7 @@ class EmailDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return \PHPMailer\PHPMailer\PHPMailer Cloned instance of the PHPMailer class
      */
-    private function clone_mail()
+    private function clone_mail(): PHPMailer
     {
         return clone $this->mail_transport;
     }
@@ -77,9 +80,9 @@ class EmailDispatcher implements PushNotificationMultiDispatcherInterface
      * @param EmailPayload $payload   Payload object
      * @param array        $endpoints Endpoints to send to in this batch
      *
-     * @return EmailResponse Response object
+     * @return PushNotificationResponseInterface&EmailResponse Response object
      */
-    public function push($payload, &$endpoints)
+    public function push(object $payload, array &$endpoints): PushNotificationResponseInterface
     {
         $payload_array = json_decode($payload->get_payload(), TRUE);
 
@@ -129,7 +132,7 @@ class EmailDispatcher implements PushNotificationMultiDispatcherInterface
      *
      * @return EmailDispatcher Self reference
      */
-    public function set_source($source)
+    public function set_source(string $source): self
     {
         $this->source = $source;
 
diff --git a/src/Lunr/Vortex/Email/EmailPayload.php b/src/Lunr/Vortex/Email/EmailPayload.php
index 7372a5ac56bd9c2f97508a35e8236d7a5a1bca3e..61856801e1793f8b84287f1289724571c114b55a 100644
--- a/src/Lunr/Vortex/Email/EmailPayload.php
+++ b/src/Lunr/Vortex/Email/EmailPayload.php
@@ -21,7 +21,7 @@ class EmailPayload
      * Array of Email Notification message elements.
      * @var array
      */
-    protected $elements;
+    protected array $elements;
 
     /**
      * Constructor.
@@ -44,7 +44,7 @@ class EmailPayload
      *
      * @return string The Email Payload
      */
-    public function get_payload()
+    public function get_payload(): string
     {
         return json_encode($this->elements);
     }
@@ -56,7 +56,7 @@ class EmailPayload
      *
      * @return EmailPayload Self Reference
      */
-    public function set_body($body)
+    public function set_body(string $body): self
     {
         $this->elements['body'] = $body;
 
@@ -70,7 +70,7 @@ class EmailPayload
      *
      * @return EmailPayload Self Reference
      */
-    public function set_subject($subject)
+    public function set_subject(string $subject): self
     {
         $this->elements['subject'] = $subject;
 
diff --git a/src/Lunr/Vortex/Email/EmailResponse.php b/src/Lunr/Vortex/Email/EmailResponse.php
index c8f8c402f4f4569f6a0a7678d116ade4148f7078..54d35f2dc81f7c1c14032dab1f7824425b0e3813 100644
--- a/src/Lunr/Vortex/Email/EmailResponse.php
+++ b/src/Lunr/Vortex/Email/EmailResponse.php
@@ -14,6 +14,7 @@ namespace Lunr\Vortex\Email;
 
 use Lunr\Vortex\PushNotificationStatus;
 use Lunr\Vortex\PushNotificationResponseInterface;
+use Psr\Log\LoggerInterface;
 
 /**
  * Email notification response wrapper.
@@ -25,19 +26,19 @@ class EmailResponse implements PushNotificationResponseInterface
      * Push notification statuses per endpoint.
      * @var array
      */
-    private $statuses;
+    private array $statuses;
 
     /**
      * Shared instance of a Logger class.
      * @var \Psr\Log\LoggerInterface
      */
-    private $logger;
+    private LoggerInterface $logger;
 
     /**
      * Raw payload that was sent out.
      * @var string
      */
-    protected $payload;
+    protected string $payload;
 
     /**
      * Constructor.
@@ -46,7 +47,7 @@ class EmailResponse implements PushNotificationResponseInterface
      * @param \Psr\Log\LoggerInterface $logger       Shared instance of a Logger.
      * @param string                   $payload      Raw payload that was sent out.
      */
-    public function __construct($mail_results, $logger, $payload)
+    public function __construct(array $mail_results, LoggerInterface $logger, string $payload)
     {
         $this->logger   = $logger;
         $this->statuses = [];
@@ -72,7 +73,7 @@ class EmailResponse implements PushNotificationResponseInterface
      *
      * @return PushNotificationStatus::* Delivery status for the endpoint
      */
-    public function get_status($endpoint)
+    public function get_status(string $endpoint): int
     {
         if (!array_key_exists($endpoint, $this->statuses))
         {
@@ -89,7 +90,7 @@ class EmailResponse implements PushNotificationResponseInterface
      *
      * @return void
      */
-    private function handle_sent_notifications($mail_results)
+    private function handle_sent_notifications(array $mail_results): void
     {
         foreach ($mail_results as $endpoint => $result_array)
         {
diff --git a/src/Lunr/Vortex/Email/Tests/EmailDispatcherPushTest.php b/src/Lunr/Vortex/Email/Tests/EmailDispatcherPushTest.php
index fc2c163dbf7f8b7bac3a32261ad5753dc1a4e9ab..1b710173affb11e5dcb18c8148b4285dae6b2a00 100644
--- a/src/Lunr/Vortex/Email/Tests/EmailDispatcherPushTest.php
+++ b/src/Lunr/Vortex/Email/Tests/EmailDispatcherPushTest.php
@@ -53,6 +53,10 @@ class EmailDispatcherPushTest extends EmailDispatcherTest
         $this->mail_transport->expects($this->once())
                              ->method('clearAddresses');
 
+        $this->mail_transport->expects($this->once())
+                             ->method('getSentMIMEMessage')
+                             ->will($this->returnValue(''));
+
         $this->assertInstanceOf('Lunr\Vortex\Email\EmailResponse', $this->class->push($this->payload, $endpoints));
 
         $this->assertEquals($this->mail_transport->Subject, 'subject');
@@ -93,6 +97,10 @@ class EmailDispatcherPushTest extends EmailDispatcherTest
         $this->mail_transport->expects($this->once())
                              ->method('clearAddresses');
 
+        $this->mail_transport->expects($this->once())
+                             ->method('getSentMIMEMessage')
+                             ->will($this->returnValue(''));
+
         $this->assertInstanceOf('Lunr\Vortex\Email\EmailResponse', $this->class->push($this->payload, $endpoints));
 
         $this->assertEquals($this->mail_transport->Subject, 'subject');
@@ -122,6 +130,10 @@ class EmailDispatcherPushTest extends EmailDispatcherTest
                              ->method('send')
                              ->will($this->returnValue(TRUE));
 
+        $this->mail_transport->expects($this->once())
+                             ->method('getSentMIMEMessage')
+                             ->will($this->returnValue(''));
+
         $this->class->push($this->payload, $endpoints);
 
         $this->unmock_method([ $this->class, 'clone_mail' ]);
diff --git a/src/Lunr/Vortex/Email/Tests/EmailDispatcherTest.php b/src/Lunr/Vortex/Email/Tests/EmailDispatcherTest.php
index 2cb56cb5934c77335a38eb76a044102d13866b4b..45a006a1d526526ca314c283a4791731717284ae 100644
--- a/src/Lunr/Vortex/Email/Tests/EmailDispatcherTest.php
+++ b/src/Lunr/Vortex/Email/Tests/EmailDispatcherTest.php
@@ -13,6 +13,7 @@ namespace Lunr\Vortex\Email\Tests;
 
 use Lunr\Vortex\Email\EmailDispatcher;
 use Lunr\Halo\LunrBaseTest;
+use Lunr\Vortex\Email\EmailPayload;
 use ReflectionClass;
 
 /**
